#!/bin/sh
###############################################################################
#                                                                             #
#       # (C)opyright by pentaprise gmbh                                      #
#                                                                             #
###############################################################################

#ident "$RCSfile: mxmail.sh,v $ $Date: 2014-12-27 20:35:38 +0100 (Sa, 27. Dez 2014) $ $Revision: 263 $"

#set -x
#exec >/tmp/lola.$$ 2>&1

TEMP=/tmp/`basename $0`.$$
sender=
attach=
recipient=
subject=
format=pdf
INFILES=

Usage()
{
    echo "Usage: $0 -r<recipient> [-a<attachment>] [-s<sender>] [-x<subject>] -f<format>"
    exit 1
}

while [ $# -gt 0 ]; do
    case "$1" in
	-a)
	    INFILES="$INFILES $2"
	    shift; shift
	    ;;
	-s)
	    sender="$2";
	    shift; shift
	    ;;
	-r)
	    recipient="$2";
	    shift; shift
	    ;;
	-x)
	    subject="-s $2";
	    shift; shift
	    ;;
	-f)
	    format="$2"
	    shift; shift
	    ;;
	*)
	    Usage
	    ;;
	--)
	    shift; break
	    ;;
    esac
done

if [ .$recipient == . ]; then
    Usage
fi

>$TEMP
cat - >>$TEMP

case $format in
    "pdf") device=pdfwrite;;
    "ps") device=pswrite;;
esac

if [ ."$device" != . ]; then
    for i in $INFILES; do
	gs -q -sDEVICE=$device -sOutputFile=$i.$format -dNOPAUSE -dBATCH $i
    done
else
    for i in $INFILES; do
	mv -f $i $i.$format;
    done
fi

for i in $INFILES; do
    attach="$attach -a $i.$format"
    RMFILES="$RMFILES $i.$format"
done

LANG=en_US.UTF-8 mutt "$subject" -e "set envelope_from=yes" -e "my_hdr From: $sender" -e "my_hdr Return-Path: $sender" -e "unset record" -e "set send_charset=\"us-ascii:iso-8859-1:iso-8859-15:utf-8\"" $attach -- $recipient < $TEMP

rm -f $TEMP $RMFILES

exit 0
