#!/bin/sh

#TF=/tmp/`basename $0`.trace
#exec 2>$TF
#set -x
#echo "$*" >>$TF

file="$1"
desttype="$2"
srctype="$3"
withcont="$4"

if [ "$file" = "" ]; then
    echo file missing
    exit 1
fi
if [ "$desttype" = "" ]; then
    echo destype missing
    exit 2
fi
if [ "$srctype" = "" ]; then
    echo srctype missing
    exit 3
fi
if [ "$withcont" = "" ]; then
    echo withcont missing
    exit 4
fi

if [ "$srctype" = "application/postscript" ]; then
    device=
    case "$desttype" in
	"application/pdf") device=pdfwrite;;
	"application/postscript") device=pswrite;;
	"image/tiff") device=tiffg4;;
    esac
    if [ ."$device" != . ]; then
	gs -dSAFER -q -sDEVICE=$device -sOutputFile=$file.$$ -dNOPAUSE -dBATCH $file
	>$file
	if [ $withcont != 0 ]; then
	    echo -e "Content-type: $desttype\n" >$file
	fi
	cat $file.$$ >>$file
	rm -f $file.$$
    else
	echo no device
	exit 6
    fi
fi

exit 0
