<?php
  require_once("/usr/share/mercaware/webstart/clients.php");

  $client = str_replace($config['global']['baseurl'] . "/", "", dirname($_SERVER['PHP_SELF']));

  // Redirect to client overview page if invalid
  if(!isset($config[$client]['port']))
  {
    if(strpos($_SERVER['PHP_SELF'], "/", strlen($_SERVER['PHP_SELF']) - 1) !== FALSE)
    {
      header("Location: ../");
    }
    else
    {
      header("Location: ./");
    }

    exit;
  }

  // Read configuration for local applet overrides
  $local = @parse_ini_file("config");

  $config[$client]['codebase'] = $config['global']['hosturl'] . dirname($_SERVER['PHP_SELF']);

  // Necessary workaround, see: http://meiert.com/de/publications/articles/20041004/
  if(stristr(isset($_SERVER['HTTP_ACCEPT']) ? $_SERVER['HTTP_ACCEPT'] : "", "application/xhtml+xml") || stristr(isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "", "W3C_Validator"))
  {
    header("Content-Type: application/xhtml+xml; charset=utf-8");
  }
  else
  {
    header("Content-Type: text/html; charset=utf-8");
  }

  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>mercaware</title>
<link rel="shortcut icon" type="image/x-icon" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/favicon.ico" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="pragma" content="no-cache" />
</head>

<body>

<!--[if !IE]> Firefox and others will use outer object -->
<object classid="java:<?php echo isset($local['APPLET_CODE']) ? htmlspecialchars($local['APPLET_CODE']) : "j2mercaware.mercawareStart"; ?>.class" type="application/x-java-applet" height="1px" width="1px">
  <!-- Konqueror browser needs the following param -->
  <param name="codebase" value="<?php echo isset($local['APPLET_CODEBASE']) ? htmlspecialchars($local['APPLET_CODEBASE']) : htmlspecialchars($config[$client]['codebase']); ?>" />
  <param name="archive" value="<?php echo isset($local['APPLET_ARCH']) ? htmlspecialchars($local['APPLET_ARCH']) : (isset($local['APPLET_JAR']) ? htmlspecialchars($local['APPLET_JAR']) : "mercaware.jar,mercawareall.jar"); ?>" />
  <param name="applet_trace" value="<?php echo isset($local['APPLET_TRACE']) ? htmlspecialchars($local['APPLET_TRACE']) : (isset($_GET['trace']) ? htmlspecialchars($_GET['trace']) : "0"); ?>" />
  <param name="osiris_port" value="<?php echo htmlspecialchars($config[$client]['port']); ?>" />
  <param name="APPLET_CACHEDURATION" value="<?php echo isset($local['APPLET_CACHEDURATION']) ? htmlspecialchars($local['APPLET_CACHEDURATION']) : "30"; ?>" />
  <param name="APPLET_FONTARCH" value="<?php echo isset($local['APPLET_FONTARCH']) ? htmlspecialchars($local['APPLET_FONTARCH']) : "mercawarefonts.jar"; ?>" />
  <param name="APPLET_DCLICKDELAY" value="<?php echo isset($local['APPLET_DCLICKDELAY']) ? htmlspecialchars($local['APPLET_DCLICKDELAY']) : ""; ?>" />
  <param name="APPLET_POSADJUST" value="<?php echo isset($local['APPLET_POSADJUST']) ? htmlspecialchars($local['APPLET_POSADJUST']) : ""; ?>" />
  <param name="APPLET_GEOMETRY" value="<?php echo isset($local['APPLET_GEOMETRY']) ? htmlspecialchars($local['APPLET_GEOMETRY']) : ""; ?>" />
  <param name="APPLET_PROXY" value="<?php echo isset($local['APPLET_PROXY']) ? htmlspecialchars($local['APPLET_PROXY']) : (isset($_GET['proxy']) ? htmlspecialchars($_GET['proxy']) : ""); ?>" />
  <param name="APPLET_HTTPOUTS" value="<?php echo isset($local['APPLET_HTTPOUTS']) ? htmlspecialchars($local['APPLET_HTTPOUTS']) : "2"; ?>" />
  <param name="CHECKINTERSECTION" value="<?php echo isset($local['APPLET_CHECKINTERSECTION']) ? htmlspecialchars($local['APPLET_CHECKINTERSECTION']) : ""; ?>" />
  <param name="APPLET_MIMECGI" value="<?php echo isset($local['APPLET_MIMECGI']) ? htmlspecialchars($local['APPLET_MIMECGI']) : ""; ?>" />
  <param name="APPLET_CRYPT" value="<?php echo isset($local['APPLET_CRYPT']) ? htmlspecialchars($local['APPLET_CRYPT']) : "0"; ?>" />
  <param name="APPLET_CLIENT" value="<?php echo isset($local['APPLET_CLIENT']) ? htmlspecialchars($local['APPLET_CLIENT']) : (isset($_GET['client']) ? htmlspecialchars($_GET['client']) : ""); ?>" />
  <param name="APPLET_USER" value="<?php echo isset($local['APPLET_USER']) ? htmlspecialchars($local['APPLET_USER']) : (isset($_GET['user']) ? htmlspecialchars($_GET['user']) : ""); ?>" />
  <param name="APPLET_PASS" value="<?php echo isset($local['APPLET_PASS']) ? htmlspecialchars($local['APPLET_PASS']) : ""; ?>" />
  <param name="APPLET_MACRO" value="<?php echo isset($local['APPLET_MACRO']) ? htmlspecialchars($local['APPLET_MACRO']) : ""; ?>" />
  <!--<![endif]-->
  <!-- MSIE (Microsoft Internet Explorer) will use inner object -->
  <object classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93" codebase="<?php echo isset($local['autodownload']) ? htmlspecialchars($local['autodownload']) : ((!empty($_SERVER['HTTPS']) ? "https://" : "http://") . "java.sun.com/update/1.6.0/jinstall-6u45-windows-i586.cab"); ?>" height="0" width="0">
    <param name="codebase" value="<?php echo isset($local['APPLET_CODEBASE']) ? htmlspecialchars($local['APPLET_CODEBASE']) : htmlspecialchars($config[$client]['codebase']); ?>" />
    <param name="code" value="<?php echo isset($local['APPLET_CODE']) ? htmlspecialchars($local['APPLET_CODE']) : "j2mercaware.mercawareStart"; ?>" />
    <param name="archive" value="<?php echo isset($local['APPLET_ARCH']) ? htmlspecialchars($local['APPLET_ARCH']) : (isset($local['APPLET_JAR']) ? htmlspecialchars($local['APPLET_JAR']) : "mercaware.jar,mercawareall.jar"); ?>" />
    <param name="applet_trace" value="<?php echo isset($local['APPLET_TRACE']) ? htmlspecialchars($local['APPLET_TRACE']) : (isset($_GET['trace']) ? htmlspecialchars($_GET['trace']) : "0"); ?>" />
    <param name="osiris_port" value="<?php echo htmlspecialchars($config[$client]['port']); ?>" />
    <param name="APPLET_CACHEDURATION" value="<?php echo isset($local['APPLET_CACHEDURATION']) ? htmlspecialchars($local['APPLET_CACHEDURATION']) : "30"; ?>" />
    <param name="APPLET_FONTARCH" value="<?php echo isset($local['APPLET_FONTARCH']) ? htmlspecialchars($local['APPLET_FONTARCH']) : "mercawarefonts.jar"; ?>" />
    <param name="APPLET_DCLICKDELAY" value="<?php echo isset($local['APPLET_DCLICKDELAY']) ? htmlspecialchars($local['APPLET_DCLICKDELAY']) : ""; ?>" />
    <param name="APPLET_POSADJUST" value="<?php echo isset($local['APPLET_POSADJUST']) ? htmlspecialchars($local['APPLET_POSADJUST']) : ""; ?>" />
    <param name="APPLET_GEOMETRY" value="<?php echo isset($local['APPLET_GEOMETRY']) ? htmlspecialchars($local['APPLET_GEOMETRY']) : ""; ?>" />
    <param name="APPLET_PROXY" value="<?php echo isset($local['APPLET_PROXY']) ? htmlspecialchars($local['APPLET_PROXY']) : (isset($_GET['proxy']) ? htmlspecialchars($_GET['proxy']) : ""); ?>" />
    <param name="APPLET_HTTPOUTS" value="<?php echo isset($local['APPLET_HTTPOUTS']) ? htmlspecialchars($local['APPLET_HTTPOUTS']) : "2"; ?>" />
    <param name="CHECKINTERSECTION" value="<?php echo isset($local['APPLET_CHECKINTERSECTION']) ? htmlspecialchars($local['APPLET_CHECKINTERSECTION']) : ""; ?>" />
    <param name="APPLET_MIMECGI" value="<?php echo isset($local['APPLET_MIMECGI']) ? htmlspecialchars($local['APPLET_MIMECGI']) : ""; ?>" />
    <param name="APPLET_CRYPT" value="<?php echo isset($local['APPLET_CRYPT']) ? htmlspecialchars($local['APPLET_CRYPT']) : "0"; ?>" />
    <param name="APPLET_CLIENT" value="<?php echo isset($local['APPLET_CLIENT']) ? htmlspecialchars($local['APPLET_CLIENT']) : (isset($_GET['client']) ? htmlspecialchars($_GET['client']) : ""); ?>" />
    <param name="APPLET_USER" value="<?php echo isset($local['APPLET_USER']) ? htmlspecialchars($local['APPLET_USER']) : (isset($_GET['user']) ? htmlspecialchars($_GET['user']) : ""); ?>" />
    <param name="APPLET_PASS" value="<?php echo isset($local['APPLET_PASS']) ? htmlspecialchars($local['APPLET_PASS']) : ""; ?>" />
    <param name="APPLET_MACRO" value="<?php echo isset($local['APPLET_MACRO']) ? htmlspecialchars($local['APPLET_MACRO']) : ""; ?>" />
  </object>
  <!--[if !IE]> close outer object -->
</object>
<!--<![endif]-->

</body>
</html>
