<?php
  // Read global mercaware webstart configuration
  $config = @parse_ini_file("/etc/mercaware/webstart", true);

  // Set some defaults if nothing was overriden
  $config['global']['hosturl'] = ((!empty($_SERVER['HTTPS'])) ? "https://" : "http://") . ((!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']);
  $config['global']['baseurl'] = (!empty($config['global']['baseurl'])) ? $config['global']['baseurl'] : "/mercaware";
  $config['global']['ess_url'] = (!empty($config['global']['ess_url'])) ? $config['global']['ess_url'] : "/ess";
  $config['global']['min_mxd'] = (!empty($config['global']['min_mxd'])) ? $config['global']['min_mxd'] : 2;
  $config['global']['jre_show'] = (!empty($config['global']['jre_show'])) ? $config['global']['jre_show'] : "6";
  $config['global']['jre_test'] = (!empty($config['global']['jre_test'])) ? $config['global']['jre_test'] : "1.6.0+";

  // Read system-wide mercaware configuration file
  $clients = @file("/etc/mercaware/clients", FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);

  // Walk through content previously read data
  if(is_array($clients))
  {
    foreach($clients as $client)
    {
      // Ignore all disabled/commented lines
      if($client[0] != "#")
      {
        // Strip all whitespaces down for column-based splitting
        $mxdinfo = explode(" ", preg_replace("/\s+/", " ", $client));

        // Get system user details from /etc/passwd
        $user = posix_getpwnam($mxdinfo[0]);

        // Proceed if requested user is a system user
        if($user !== false)
        {
          // Unfortunately not very elegant, but at least somehow working
          // Java applet supports (10/2012) still only ISO-8859-1 in window tile bar
          $name = iconv("ISO-8859-1", "UTF-8", trim(shell_exec(". " . escapeshellcmd($user['dir']) . "/etc/mxdrc >> /dev/null 2>&1; echo \$MXMANDANT")));

          // Set the client name and defaults
          $config[$mxdinfo[0]]['name'] = (!empty($config[$mxdinfo[0]]['name'])) ? $config[$mxdinfo[0]]['name'] : ((!empty($name)) ? $name : "Unbenannter Mandant");
          $config[$mxdinfo[0]]['port'] = (!empty($config[$mxdinfo[0]]['port'])) ? $config[$mxdinfo[0]]['port'] : $mxdinfo[1];
          $config[$mxdinfo[0]]['procs'] = 0;
          $config[$mxdinfo[0]]['home'] = $user['dir'];
          $config[$mxdinfo[0]]['jre_show'] = (!empty($config[$mxdinfo[0]]['jre_show'])) ? $config[$mxdinfo[0]]['jre_show'] : $config['global']['jre_show'];
          $config[$mxdinfo[0]]['jre_test'] = (!empty($config[$mxdinfo[0]]['jre_test'])) ? $config[$mxdinfo[0]]['jre_test'] : $config['global']['jre_test'];

          // Only lookup path if not configured
          if(empty($config[$mxdinfo[0]]['applet']))
          {
            if(is_readable($user['dir'] . "/htdocs/index.php"))
            {
              $config[$mxdinfo[0]]['applet'] = $config['global']['baseurl'] . "/" . $mxdinfo[0] . "/applet/";
            }
            elseif(is_executable($user['dir'] . "/docroot/essj2.cgi"))
            {
              $config[$mxdinfo[0]]['applet'] = $config['global']['ess_url'] . "/" . $mxdinfo[0] . "/essj2.cgi";
            }
            elseif(is_executable($user['dir'] . "/docroot/ess.cgi"))
            {
              $config[$mxdinfo[0]]['applet'] = $config['global']['ess_url'] . "/" . $mxdinfo[0] . "/ess.cgi";
            }
          }

          if(empty($config[$mxdinfo[0]]['desktop']))
          {
            if(is_readable($user['dir'] . "/htdocs/desktop.php"))
            {
              $config[$mxdinfo[0]]['desktop'] = $config['global']['baseurl'] . "/" . $mxdinfo[0] . "/desktop/";
            }
          }
        }
      }
    }
  }

  if(function_exists("date_default_timezone_set") && !ini_get("date.timezone"))
  {
    date_default_timezone_set("Europe/Berlin");
  }
?>
