<?php
  require_once("/usr/share/mercaware/webstart/clients.php");

  $client = str_replace($config['global']['baseurl'] . "/", "", dirname($_SERVER['PHP_SELF']));

  // Redirect to client overview page if invalid
  if(!isset($config[$client]['port']))
  {
    if(strpos($_SERVER['PHP_SELF'], "/", strlen($_SERVER['PHP_SELF']) - 1) !== FALSE)
    {
      header("Location: ../");
    }
    else
    {
      header("Location: ./");
    }

    exit;
  }

  // Read configuration for local applet overrides
  $local = @parse_ini_file("config");

  $config[$client]['codebase'] = $config['global']['hosturl'] .  (isset($local['APPLET_CODEBASE']) ? $local['APPLET_CODEBASE'] : dirname($_SERVER['PHP_SELF']));

  // Check if an argument for IcedTea has been passed, see also:
  // http://icedtea.classpath.org/bugzilla/show_bug.cgi?id=725
  if(isset($_SERVER['QUERY_STRING']) && $_SERVER['QUERY_STRING'] == "icedtea")
  {
    $icedtea = 1;
  }
  else
  {
    $icedtea = 0;
  }

  header("Content-Type: application/x-java-jnlp-file; charset=utf-8");
  header("Content-Disposition: " . (($icedtea) ? "attachment" : "inline") . "; filename=\"mercaware.jnlp\"");
  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<jnlp spec="<?php echo htmlspecialchars($config[$client]['jre_test']); ?>" codebase="<?php echo htmlspecialchars($config[$client]['codebase']); ?>" href="desktop/<?php if($icedtea) { echo "?icedtea"; } ?>">
  <information>
    <title>mercaware <?php echo htmlspecialchars($config[$client]['name']); ?></title>
    <vendor>All for Accounting GmbH</vendor>
    <homepage href="http://www.mercaware.de/" />
    <description>ERP-Software mercaware für KMU</description>
    <icon kind="shortcut" href="../favicon.ico" />
<?php
  if(!$icedtea)
  {
?>
    <shortcut online="true" install="true">
      <desktop />
    </shortcut>
<?php
  }
?>
  </information>
  <update check="always" policy="always" />
  <security>
    <all-permissions />
  </security>
  <resources>
    <j2se version="<?php echo htmlspecialchars($config[$client]['jre_test']); ?>" href="https://java.sun.com/products/autodl/j2se" />
    <jar href="mercaware.jar" part="true" main="true" />
    <jar href="mercawareall.jar" part="true" />
    <jar href="mercawarefonts.jar" part="true" />
  </resources>
  <application-desc main-class="<?php echo isset($local['APPLET_CODE']) ? htmlspecialchars($local['APPLET_CODE']) : "j2mercaware.mercawareStart"; ?>">
    <argument><?php echo htmlspecialchars($config['global']['hosturl'] . $config[$client]['applet']); ?></argument>
  </application-desc>
</jnlp>
