<?php
  require_once("/usr/share/mercaware/webstart/clients.php");

  // Get the process list for with running MXD processes
  $processes = explode("\n", trim(shell_exec("LANG=C COLUMNS=512 ps aux | grep bin/mxd")));

  // Walk through content previously read data
  foreach($processes as $process)
  {
    // Strip all whitespaces down for column-based splitting
    $columns = explode(" ", preg_replace("/\s+/", " ", preg_replace("/^\s+/", "", $process)));

    // Increment counter per client for every MXD process
    if(isset($config[$columns[0]]) && $columns[10] == "bin/mxd")
    {
      $config[$columns[0]]['procs'] += 1;
    }
  }

  // Walk through all elements in configuration
  foreach(array_keys($config) as $client)
  {
    // Only proceed if element is a mercaware client
    if(!in_array($client, array("global", "visible")))
    {
      // Ignore client invisibility if there's a visibility list for this host
      if(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
      {
        // Set invisible if client option is exists and is set
        if(isset($config[$client]['invisible']) && $config[$client]['invisible'])
        {
          unset($config[$client]);
        }
      }

      // Walk through all visibility hostnames
      if(isset($config['visible']))
      {
        foreach(array_keys($config['visible']) as $host)
        {
          // If value is not an array, make it an array
          if(!is_array($config['visible'][$host]))
          {
            $config['visible'][$host] = array($config['visible'][$host]);
          }

          // Set invisible if hostname matches and client is not on visible list
          if(($host == $_SERVER['SERVER_NAME'] || $host == $_SERVER['SERVER_ADDR']) && !in_array($client, $config['visible'][$host]) && !in_array("*", $config['visible'][$host]))
          {
            unset($config[$client]);
          }

          // Set invisible if hostname does not match (avoid invalid subdomains)
          elseif(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
          {
            unset($config[$client]);
          }
        }
      }
    }
  }

  // Detect if the client browser is Linux (for raising the IcedTea question later)
  if(isset($_SERVER['HTTP_USER_AGENT']) && stristr($_SERVER['HTTP_USER_AGENT'], "Linux") !== FALSE)
  {
    $icedtea = 1;
  }
  else
  {
    $icedtea = 0;
  }

  // Necessary workaround, see: http://meiert.com/de/publications/articles/20041004/
  if(stristr(isset($_SERVER['HTTP_ACCEPT']) ? $_SERVER['HTTP_ACCEPT'] : "", "application/xhtml+xml") || stristr(isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "", "W3C_Validator"))
  {
    header("Content-Type: application/xhtml+xml; charset=utf-8");
  }
  else
  {
    header("Content-Type: text/html; charset=utf-8");
  }

  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>mercaware</title>
<link rel="shortcut icon" type="image/x-icon" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/favicon.ico" />
<link rel="stylesheet" type="text/css" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/screen.css" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="pragma" content="no-cache" />
<script src="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/java.js" type="text/javascript"></script>
<script type="text/javascript">
/* <![CDATA[ */
  var shortcut = false;
<?php
  if($icedtea)
  {
?>
  var icedtea = false;
<?php
  }
?>

  function mercaware(client, applet, jnlp, jre_show, jre_test)
  {
    if(shortcut)
    {
      shortcut = false;
      if(jnlp)
      {
<?php
  if($icedtea)  
  {
?>
        if(icedtea)
        {
          document.getElementById('applet-' + client).innerHTML = "<iframe src='" + jnlp + "?icedtea' width='1px' height='1px' />";
          icedtea = false;
        }
        else
        {
          document.getElementById('applet-' + client).innerHTML = "<iframe src='" + jnlp + "' width='1px' height='1px' />";
        }
<?php
  }
  else
  {
?>
        document.getElementById('applet-' + client).innerHTML = "<iframe src='" + jnlp + "' width='1px' height='1px' />";
<?php
  }
?>
      }
      else
      {
        alert("Dieser mercaware-Mandant unterstützt keinen Desktop-Starter,\nbitte wenden Sie sich an Ihren Administrator.");
      }
    }
    else
    {
      if(applet)
      {
        document.getElementById('applet-' + client).innerHTML = "<iframe src='" + applet + "' width='1px' height='1px' />";
      }
      else
      {
        alert("Dieser mercaware-Mandant ist nicht konfiguriert,\nbitte wenden Sie sich an Ihren Administrator.");
      }
    }

    if(deployJava.getJREs().length == 0)
    {
      if(confirm("Zur Benutzung von mercaware benötigen Sie Java\nin Version " + jre_show + " (oder neuer) welches bei Ihnen leider\nnoch nicht installiert ist.\n\nMöchten Sie Java jetzt installieren?"))
      {
        deployJava.returnPage = "<?php echo htmlspecialchars($config['global']['hosturl'] . $config['global']['baseurl']); ?>/";
        deployJava.installLatestJRE();
      }
    }
    else if(deployJava.versionCheck(jre_test) == false)
    {
      if(confirm("Zur Benutzung von mercaware benötigen Sie Java\nin Version " + jre_show + " (oder neuer) während bei Ihnen leider\nnoch eine ältere Version installiert ist.\n\nMöchten Sie Java jetzt aktualisieren?"))
      {
        deployJava.returnPage = "<?php echo htmlspecialchars($config['global']['hosturl'] . $config['global']['baseurl']); ?>/";
        deployJava.installLatestJRE(); 
      }
    }
  }

  function starter()
  {
    if(confirm("Um einen Desktop-Starter für einen mercaware-Mandanten anzulegen\nklicken Sie auf \"OK\" und starten danach den gewünschten Mandanten.\nAnsonsten klicken Sie bitte auf \"Abbrechen\".\n\nMöchten Sie jetzt einen Desktop-Starter anlegen?"))
    {
      shortcut = true;
<?php
  if($icedtea)
  {
?>

      if(confirm("Wenn Sie OpenJDK bzw. IcedTea nutzen klicken Sie auf \"OK\". Falls\nSie Oracle Java verwenden oder sich nicht sicher sind klicken Sie\nbitte einfach auf \"Abbrechen\".\n\nVergessen Sie bitte nicht den gewünschten Mandanten zu starten\num den Desktop-Starter für den mercaware-Mandanten anzulegen."))
      {
        icedtea = true;
      }
      else
      {
        icedtea = false;
      }
<?php
  }
?>
    }
    else
    {
      shortcut = false;
    }
  }
/* ]]> */
</script>
<!--[if IE 6]>
<script src="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/pngfix.js"></script>
<script>
  DD_belatedPNG.fix('.active a, .link');
</script>
<style>
body{text-align:center;}
#container{width:800px;background:#fff;}
#left ul{margin-top:-23px;}
</style>
<![endif]--> 
</head>

<body>

<div id="wrapper">
  <h1>mercaware</h1>

  <div id="container">
    <div id="left">
      <h2>Mandanten</h2>
      <ul>
<?php
  $clients = 0;

  foreach(array_keys($config) as $client)
  {
    if(!in_array($client, array("global", "visible")))
    {
      $clients++;

      if($config[$client]['procs'] >= $config['global']['min_mxd'] && !empty($config[$client]['applet']))
      {
?>
        <li class="active"><a title="Mandant aktiv" onclick="mercaware('<?php echo implode("', '", array(htmlspecialchars($client), htmlspecialchars($config[$client]['applet']), htmlspecialchars($config[$client]['desktop']), htmlspecialchars($config[$client]['jre_show']), htmlspecialchars($config[$client]['jre_test']))); ?>'); this.blur(); return false;" href="#"><span class="name"><?php echo htmlspecialchars($client); ?><span class="print">: </span></span><?php echo htmlspecialchars($config[$client]['name']); ?></a></li>
<?php
      }
      else
      {
?>
       <li><span class="link"><span class="name"><?php echo htmlspecialchars($client); ?><span class="print">: </span></span><?php echo htmlspecialchars($config[$client]['name']); ?></span></li>
<?php
      }
    }
  }

  if(!$clients)
  {
?>
      </ul>
      <div style="text-align:center">Im Moment sind keine Mandanten vorhanden</div>
<?php
  }
  else
  {
?>
      </ul>
<?php
  }
?>
    </div>

    <div id="right">
      <h2>Werkzeuge</h2>
      <ul>
        <li><a title="Handbuch von mercaware" onclick="window.open(this.href); this.blur(); return false;" href="<?php echo htmlspecialchars($config['global']['baseurl'] . "/" . $client . "/handbuch/"); ?>">Handbuch</a></li>
        <li><a title="Auslastung des Systems durch Benutzer" onclick="window.open(this.href); this.blur(); return false;" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>-monitor/">Systemmonitor</a></li>
        <li><a title="Aktuelle Nutzung der Lizenzen" onclick="window.open(this.href); this.blur(); return false;" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>-lizenzen/">Lizenznutzung</a></li>
        <li><a title="Aktuell installierte Versionen" onclick="window.open(this.href); this.blur(); return false;" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>-versionen/">Versionsstände</a></li>
        <li><a title="Desktop-Verknüpfung anlegen" onclick="starter(); this.blur(); return false;" href="#">Desktop-Starter</a></li>
        <li><a title="Weitere Informationen zu mercaware" onclick="window.open(this.href); this.blur(); return false;" href="http://www.mercaware.de/">Über mercaware</a></li>
      </ul>
    </div>

    <div class="clear"></div>

<?php
  foreach(array_keys($config) as $client)
  {
    if(!in_array($client, array("global", "visible")))
    {
      if($config[$client]['procs'] >= $config['global']['min_mxd'] && !empty($config[$client]['applet']))
      {
?>
    <div id="applet-<?php echo htmlspecialchars($client); ?>" class="applet"></div>
<?php
      }
    }
  }
?>
  </div>
</div>

</body>
</html>
