<?php
  require_once("/usr/share/mercaware/webstart/clients.php");

  $users = array();

  // Walk through all configurations for the PostgreSQL database users
  foreach($config as $name => $client)
  {
    if(array_key_exists("home", $client))
    {
      $home = escapeshellcmd($client['home']);
      $cmds = array("cd " . $home,
                    "if [ -f .bashrc ]; then . " . $home . "/.bashrc >> /dev/null 2>&1; fi",
                    "if [ -f .profile ]; then . " . $home . "/.profile >> /dev/null 2>&1; fi",
                    ". " . $home . "/etc/mxdbsrc >> /dev/null 2>&1",
                    "echo \$PGHOST:\$PGPORT:\$PGDATABASE:\${PGUSER:-\$MXDBUSER}:\${PGPASSWORD:-\$MXDBPASSWD}");

      // Unfortunately not very elegant, but working
      list($server, $port, $database, $username, $password) = explode(":", trim(shell_exec(implode("; ", $cmds))));

      // Pentaprise favoured using $HOME/.odbc.ini
      $odbc = @parse_ini_file($client['home'] . "/.odbc.ini", true);

      $config['db'][$name]['server'] = (!empty($server) ? $server : (!isset($odbc['PostgreSQL']['Servername']) ? $odbc['PostgreSQL']['Servername'] : "localhost"));
      $config['db'][$name]['port'] = (!empty($port) ? $port : (!isset($odbc['PostgreSQL']['Port']) ? $odbc['PostgreSQL']['Port'] : 5432));
      $config['db'][$name]['database'] = (!empty($database) ? $database : (!isset($odbc['PostgreSQL']['Database']) ? $odbc['PostgreSQL']['Database'] : "MXDBS"));
      $config['db'][$name]['username'] = (!empty($username) ? $username : "postgres");
      $config['db'][$name]['password'] = (!empty($password) ? $password : "");
    }
  }

  // Connect all PostgreSQL databases and select license usages
  if(isset($config['db']))
  {
    foreach($config['db'] as $client => $db)
    {
      $link = @pg_connect("host='" . $config['db'][$client]['server'] . "' " .
                          "port='" . $config['db'][$client]['port'] . "' " .
                          "dbname='" . $config['db'][$client]['database'] . "' " .
                          "user='" . $config['db'][$client]['username'] . "' " .
                          "password='" . $config['db'][$client]['password'] . "'");
 
      if($link)
      {
        $result = pg_query($link, "SELECT manr, MAX(dat::text::date + zeit::text::time) AS login, mxpid, ripadr, rhost FROM utmp WHERE conid != 0 GROUP BY manr, mxpid, ripadr, rhost ORDER BY manr, login");

        while($row = pg_fetch_assoc($result))
        {
          $users[$client][] = $row;
        }

        pg_free_result($result);

        @pg_close($link);
      }
    }
  }

  // Walk through all elements in configuration
  foreach(array_keys($config) as $client)
  {
    // Only proceed if element is a mercaware client
    if(!in_array($client, array("global", "visible", "db")))
    {
      // Ignore client invisibility if there's a visibility list for this host
      if(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
      {
        // Set invisible if client option is exists and is set
        if(isset($config[$client]['invisible']) && $config[$client]['invisible'])
        {
          unset($config[$client]);
        }
      }

      // Walk through all visibility hostnames
      if(isset($config['visible']))
      {
        foreach(array_keys($config['visible']) as $host)
        {
          // If value is not an array, make it an array
          if(!is_array($config['visible'][$host]))
          {
            $config['visible'][$host] = array($config['visible'][$host]);
          }

          // Set invisible if hostname matches and client is not on visible list
          if(($host == $_SERVER['SERVER_NAME'] || $host == $_SERVER['SERVER_ADDR']) && !in_array($client, $config['visible'][$host]) && !in_array("*", $config['visible'][$host]))
          {
            unset($config[$client]);
          }

          // Set invisible if hostname does not match (avoid invalid subdomains)
          elseif(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
          {
            unset($config[$client]);
          }
        }
      }
    }
  }

  // Remove system processes and hidden/invisible clients from the process list
  foreach($users as $client => $utmp)
  {
    if(!array_key_exists($client, $config))
    {
      unset($users[$client]);
    }
  }

  // Necessary workaround, see: http://meiert.com/de/publications/articles/20041004/
  if(stristr(isset($_SERVER['HTTP_ACCEPT']) ? $_SERVER['HTTP_ACCEPT'] : "", "application/xhtml+xml") || stristr(isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "", "W3C_Validator"))
  {
    header("Content-Type: application/xhtml+xml; charset=utf-8");
  }
  else
  {
    header("Content-Type: text/html; charset=utf-8");
  }

  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
<head>
<title>Lizenznutzung – mercaware</title>
<link rel="shortcut icon" type="image/x-icon" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/favicon.ico" />
<link rel="stylesheet" type="text/css" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/screen.css" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="pragma" content="no-cache" />
<!--[if lte IE 6]>
<script src="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/pngfix.js"></script>
<script>
  DD_belatedPNG.fix('.active a, .link');
</script>
<style>
body{text-align:center;}
#container{width:800px;background:#fff;}
#left ul{margin-top:-23px;}
</style>
<![endif]--> 
</head> 

<body>  
  
<div id="wrapper">
  <h1>mercaware</h1>
  <div id="container">
    <h2>Lizenznutzung</h2>
<?php
  if($number = count($users))
  {
?>
    <table>
      <thead>
        <tr>
          <th class="col_first">Benutzer</th>
          <th>Mandant</th>
          <th class="col_right">PID</th>
          <th>Angemeldet seit</th>
          <th class="col_last">IP-Adresse</th>
        </tr>
      </thead>
      <tbody>
<?php
    $i = 0;

    foreach($users as $client => $utmp)
    {
      foreach($utmp as $user)
      {
?>
        <tr class="row_<?php echo $i; ?><?php if($i == 0) { ?> row_first<?php } elseif($i == $number-1) { ?> row_last<?php } ?><?php echo ($i % 2) ? ' even' : ' odd'; ?>">
          <td class="col_first"><?php echo htmlspecialchars($user['manr']); ?></td>
          <td><a title="Name: <?php echo htmlspecialchars($config[$client]['name']); ?>"><?php echo htmlspecialchars($client); ?></a></td>
          <td class="col_right"><?php echo htmlspecialchars($user['mxpid']); ?></td>
          <td><?php echo strftime("%d.%m.%Y %H:%M", strtotime($user['login'])); ?></td>
          <td class="col_last"><?php if($user['rhost'] != "unknown") { ?><a title="Hostname: <?php echo htmlspecialchars($user['rhost']); ?>"><?php } echo long2ip(hexdec($user['ripadr'])); if($user['rhost'] != "unknown") { ?></a><?php } ?></td>
        </tr>
<?php
        $i++;
      }
    }
?>
      </tbody>
    </table>
<?php
  }
  else
  {
?>
    <p style="text-align:center">Im Moment werden keine Lizenzen benutzt</p>
<?php
  }
?>
    <div class="clear"></div>
  </div>
</div>

</body>
</html>
