<?php
  require_once("/usr/share/mercaware/webstart/clients.php");

  $relations = array();

  // Walk through all configurations for the PostgreSQL database users
  foreach($config as $name => $client)
  {
    if(array_key_exists("home", $client))
    {
      $home = escapeshellcmd($client['home']);
      $cmds = array("cd " . $home,
                    "if [ -f .bashrc ]; then . " . $home . "/.bashrc >> /dev/null 2>&1; fi",
                    "if [ -f .profile ]; then . " . $home . "/.profile >> /dev/null 2>&1; fi",
                    ". " . $home . "/etc/mxdbsrc >> /dev/null 2>&1",
                    "echo \$PGHOST:\$PGPORT:\$PGDATABASE:\${PGUSER:-\$MXDBUSER}:\${PGPASSWORD:-\$MXDBPASSWD}");

      // Unfortunately not very elegant, but working
      list($server, $port, $database, $username, $password) = explode(":", trim(shell_exec(implode("; ", $cmds))));

      // Pentaprise favoured using $HOME/.odbc.ini
      $odbc = @parse_ini_file($client['home'] . "/.odbc.ini", true);

      $config['db'][$name]['server'] = (!empty($server) ? $server : (!isset($odbc['PostgreSQL']['Servername']) ? $odbc['PostgreSQL']['Servername'] : "localhost"));
      $config['db'][$name]['port'] = (!empty($port) ? $port : (!isset($odbc['PostgreSQL']['Port']) ? $odbc['PostgreSQL']['Port'] : 5432));
      $config['db'][$name]['database'] = (!empty($database) ? $database : (!isset($odbc['PostgreSQL']['Database']) ? $odbc['PostgreSQL']['Database'] : "MXDBS"));
      $config['db'][$name]['username'] = (!empty($username) ? $username : "postgres");
      $config['db'][$name]['password'] = (!empty($password) ? $password : "");
    }
  }

  // Connect all maybe later required or used PostgreSQL databases
  if(isset($config['db']))
  {
    foreach($config['db'] as $client => $db)
    {
      $link[$client] = @pg_connect("host='" . $config['db'][$client]['server'] . "' " .
                                   "port='" . $config['db'][$client]['port'] . "' " .
                                   "dbname='" . $config['db'][$client]['database'] . "' " .
                                   "user='" . $config['db'][$client]['username'] . "' " .
                                   "password='" . $config['db'][$client]['password'] . "'");
    }
  }

  // Get the process list ordered per CPU usage descending
  $lines = explode("\n", trim(shell_exec("LANG=C COLUMNS=512 top -b -n 1 -c")));
  $config['count'] = 0;

  foreach($lines as $line)
  {
    if($config['count'] > 5)
    {
      // Strip all whitespaces down for column-based splitting
      $columns = explode(" ", preg_replace("/\s+/", " ", preg_replace("/^\s+/", "", $line)));
      $command = "";

      // Join all parts of the command of the top output into one string
      for($i = 11; $i < count($columns); $i++)
      {
        $command .= $columns[$i];

        if($i < count($columns) - 1)
        {
          $command .= " ";
        }
      }

      // Add to process list if it's not header line
      if($columns[8] != "%CPU" && $columns[9] != "%MEM")
      {
        $procs[$columns[0]]['user']     = $columns[1];
        $procs[$columns[0]]['cpu']      = $columns[8];
        $procs[$columns[0]]['mem']      = $columns[9];
        $procs[$columns[0]]['time']     = $columns[10];
        $procs[$columns[0]]['command']  = "Prozess: " . $command;
        $procs[$columns[0]]['rpid']     = "-";
        $procs[$columns[0]]['mxproc']   = 0;
        $procs[$columns[0]]['mxclient'] = "-";
        $procs[$columns[0]]['mxtype']   = "Regular system process";
        $procs[$columns[0]]['mxuser']   = "-";
      }

      // If the process is a MXD process connect database and lookup the user to add
      if($columns[11] == "bin/mxd")
      {
        // Does the username exist as client name as connected PostgreSQL database?
        if(!empty($link[$columns[1]]))
        {
          // Fetch the mercaware username related to the PID from the mercaware database
          $result = pg_query($link[$columns[1]], "SELECT manr FROM utmp WHERE mxpid = " . $columns[0]);
          $row = pg_fetch_assoc($result);

          // ESS 5.x and some broken ESS 6.x do not have special ESS users for preloaded MXD instances
          if(empty($row['manr']))
          {
            $row['manr'] = "?";
          }

          // Add some useful information for later printing for the end user
          $procs[$columns[0]]['mxproc']   = 1;
          $procs[$columns[0]]['mxclient'] = $columns[1];
          $procs[$columns[0]]['mxtype']   = "mercaware-Applikationsserver";
          $procs[$columns[0]]['mxuser']   = $row['manr'];
        }
      }
    }

    $config['count'] += 1;
  }

  // Disconnect all maybe opened or used PostgreSQL databases again
  if(isset($config['db']))
  {
    foreach($config['db'] as $client => $db)
    {
      @pg_close($link[$client]);
    }
  }

  // Get all TCP network connections which are LISTEN and MXND, so that we can exclude them later
  if(is_file("/usr/libexec/mercaware-stat"))
  {
    $lines = explode("\n", trim(shell_exec("LANG=C /usr/libexec/mercaware-stat mxnd")));

    foreach($lines as $line)
    {
      // Strip all whitespaces down for column-based splitting
      $columns = explode(" ", preg_replace("/\s+/", " ", preg_replace("/(\/|:)/", " ", str_replace("::ffff:", "", $line))));

      // Push the MXND listen port to an array for later usage
      if(isset($columns[4]))
      {
        $config['mxnd'][] = $columns[4];
      }
    } 
  }
  else
  {
    die("Error: There is no '/usr/libexec/mercaware-stat' binary with setuid permissions!");
  }

  // Get all TCP network connections which are ESTABLISHED and 127.0.0.1, but not related to mxlicd
  if(is_file("/usr/libexec/mercaware-stat"))
  {
    $lines = array_filter(explode("\n", trim(shell_exec("LANG=C /usr/libexec/mercaware-stat"))));

    foreach($lines as $line)
    {
      // Strip all whitespaces down for column-based splitting
      $columns = explode(" ", preg_replace("/\s+/", " ", preg_replace("/(\/|:)/", " ", str_replace("::ffff:", "", $line))));

      // Following is only performed for non-MXND related TCP connections
      if(!in_array($columns[6], $config['mxnd']))
      {
        // If the network connection belongs to a MXD process, get the PostgreSQL database port (otherwise the other way round)
        if($columns[10] == "mxd")
        {
          $relations[$columns[8]]['name'] = "bin/mxd";
          $relations[$columns[8]]['port'] = $columns[4];
        }
        elseif($columns[9] == "postgres")
        {
          $relations[$columns[8]]['name'] = "postgres:";
          $relations[$columns[8]]['port'] = $columns[6];
        }
      }
    }
  }
  else
  {
    die("Error: There is no '/usr/libexec/mercaware-stat' binary with setuid permissions!");
  }

  // Walk through the relations of the previously gathered network connections and map them
  foreach($relations as $pid_mx => $relation_mx)
  {
    // If the network connection belongs to a MXD process
    if($relations[$pid_mx]['name'] == "bin/mxd")
    {
      // Walk for each MXD process through all previously gathered network connections again
      foreach($relations as $pid_pg => $relation_pg)
      {
        // If the network connection belongs to a PostgreSQL process and the port matches with a MXD process
        if($relations[$pid_pg]['name'] == "postgres:" && $relations[$pid_pg]['port'] == $relations[$pid_mx]['port'])
        {
          // Add some useful information for later printing for the end user
          $procs[$pid_pg]['mxproc']   = 1;
          $procs[$pid_pg]['mxclient'] = $procs[$pid_mx]['mxclient'];
          $procs[$pid_pg]['mxtype']   = "PostgreSQL-Datenbankserver";
          $procs[$pid_pg]['mxuser']   = $procs[$pid_mx]['mxuser'];
          $procs[$pid_pg]['rpid']     = "PID des mercaware-Applikationsservers: " . $pid_mx;
          $procs[$pid_mx]['rpid']     = "PID des PostgreSQL-Datenbankservers: " . $pid_pg;
        }
      }
    }
  }

  // Walk through all elements in configuration
  foreach(array_keys($config) as $client)
  {
    // Only proceed if element is a mercaware client
    if(!in_array($client, array("global", "visible", "db", "count", "mxnd")))
    {
      // Ignore client invisibility if there's a visibility list for this host
      if(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
      {
        // Set invisible if client option is exists and is set
        if(isset($config[$client]['invisible']) && $config[$client]['invisible'])
        {
          unset($config[$client]);
        }
      }

      // Walk through all visibility hostnames
      if(isset($config['visible']))
      {
        foreach(array_keys($config['visible']) as $host)
        {
          // If value is not an array, make it an array
          if(!is_array($config['visible'][$host]))
          {
            $config['visible'][$host] = array($config['visible'][$host]);
          }

          // Set invisible if hostname matches and client is not on visible list
          if(($host == $_SERVER['SERVER_NAME'] || $host == $_SERVER['SERVER_ADDR']) && !in_array($client, $config['visible'][$host]) && !in_array("*", $config['visible'][$host]))
          {
            unset($config[$client]);
          }

          // Set invisible if hostname does not match (avoid invalid subdomains)
          elseif(!isset($config['visible'][$_SERVER['SERVER_NAME']]) && !isset($config['visible'][$_SERVER['SERVER_ADDR']]))
          {
            unset($config[$client]);
          }
        }
      }
    }
  }

  // Remove system processes and hidden/invisible clients from the process list
  foreach($procs as $pid => $proc)
  {
    if($procs[$pid]['mxproc'] == 0 || !array_key_exists($procs[$pid]['mxclient'], $config))
    {
      unset($procs[$pid]);
    }
  }
 
  // Necessary workaround, see: http://meiert.com/de/publications/articles/20041004/
  if(stristr(isset($_SERVER['HTTP_ACCEPT']) ? $_SERVER['HTTP_ACCEPT'] : "", "application/xhtml+xml") || stristr(isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "", "W3C_Validator"))
  {
    header("Content-Type: application/xhtml+xml; charset=utf-8");
  }
  else
  {
    header("Content-Type: text/html; charset=utf-8");
  }

  echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  
<head>
<title>Systemmonitor – mercaware</title>
<link rel="shortcut icon" type="image/x-icon" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/favicon.ico" />
<link rel="stylesheet" type="text/css" href="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/screen.css" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="pragma" content="no-cache" />
<!--[if lte IE 6]>
<script src="<?php echo htmlspecialchars($config['global']['baseurl']); ?>/pngfix.js"></script>
<script>
  DD_belatedPNG.fix('.active a, .link');
</script>
<style>
body{text-align:center;}
#container{width:800px;background:#fff;}
#left ul{margin-top:-23px;}
</style>
<![endif]--> 
</head> 

<body>  
  
<div id="wrapper">
  <h1>mercaware</h1>
  <div id="container">
    <h2>Systemmonitor</h2>
<?php
  if($number = count($procs))
  {
?>
    <table>
      <thead>
        <tr>
          <th class="col_first">Benutzer</th>
          <th class="col_right">CPU</th>
          <th class="col_right">Speicher</th>
          <th>Prozesstyp</th>
          <th>Mandant</th>
          <th class="col_right">Laufzeit</th>
          <th class="col_right col_last">PID</th>
        </tr>
      </thead>
      <tbody>
<?php
    $i = 0;

    foreach($procs as $pid => $proc)
    {
?>
        <tr class="row_<?php echo $i; ?><?php if($i == 0) { ?> row_first<?php } elseif($i == $number-1) { ?> row_last<?php } ?><?php echo ($i % 2) ? ' even' : ' odd'; ?>">
          <td class="col_first"><?php echo htmlspecialchars($proc['mxuser']); ?></td>
          <td class="col_right"><?php echo htmlspecialchars($proc['cpu']); ?> %</td>
          <td class="col_right"><?php echo htmlspecialchars($proc['mem']); ?> %</td>
          <td><?php echo htmlspecialchars($proc['mxtype']); ?></td>
          <td><a title="Name: <?php echo htmlspecialchars($config[$proc['mxclient']]['name']); ?>"><?php echo htmlspecialchars($proc['mxclient']); ?></a></td>
          <td class="col_right"><a title="<?php echo htmlspecialchars($proc['command']); ?>"><?php echo htmlspecialchars($proc['time']); ?></a></td>
          <td class="col_right col_last"><?php if($proc['rpid'] != "-") { ?><a title="<?php echo htmlspecialchars($proc['rpid']); ?>"><?php } echo htmlspecialchars($pid); if($proc['rpid'] != "-") { ?></a><?php } ?></td>
        </tr>
<?php
      $i++;
    }
?>
      </tbody>
    </table>
<?php
  }
  else
  {
?>
    <p style="text-align:center">Im Moment sind keine Daten vorhanden</p>
<?php
  }
?>
    <div class="clear"></div>
  </div>
</div>

</body>
</html>
